'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var _Traverse = require('../../Traverse');

var _Traverse2 = _interopRequireDefault(_Traverse);

var Program = (function (_Statement) {
    _inherits(Program, _Statement);

    function Program(childNodes) {
        _classCallCheck(this, Program);

        _get(Object.getPrototypeOf(Program.prototype), 'constructor', this).call(this, 'Program', childNodes);

        this._isProgram = true;
        this._traverse = new _Traverse2['default']();
        this._traverse.addElements(childNodes);
        this._eventListeners = {};
    }

    _createClass(Program, [{
        key: '_acceptPlugins',
        value: function _acceptPlugins(plugins) {
            Object.freeze(plugins);
            this._plugins = plugins;
        }
    }, {
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            if (children.isToken('Hashbang')) {
                children.passToken('Hashbang');
            }

            children.skipNonCode();

            var body = [];
            while (children.isStatement()) {
                body.push(children.passStatement());
                children.skipNonCode();
            }

            children.passToken('EOF');
            children.assertEnd();

            this._body = body;
        }

        /**
         * Returns node list with specified type from the tree.
         *
         * @param {String} type
         * @returns {Node[]}
         */
    }, {
        key: 'selectNodesByType',
        value: function selectNodesByType(type) {
            return this._traverse.selectNodesByType(type);
        }

        /**
         * Returns tokens list with specified type from the tree.
         *
         * @param {String} type
         * @returns {Token[]}
         */
    }, {
        key: 'selectTokensByType',
        value: function selectTokensByType(type) {
            return this._traverse.selectTokensByType(type);
        }
    }, {
        key: '_addElementsToProgram',
        value: function _addElementsToProgram(elements) {
            this._traverse.addElements(elements);
            this._emit('elements-add', elements);
        }
    }, {
        key: '_removeElementsFromProgram',
        value: function _removeElementsFromProgram(elements) {
            this._traverse.removeElements(elements);
            this._emit('elements-remove', elements);
        }
    }, {
        key: 'on',
        value: function on(eventName, callback) {
            if (this._eventListeners[eventName]) {
                this._eventListeners[eventName].push(callback);
            } else {
                this._eventListeners[eventName] = [callback];
            }
        }
    }, {
        key: 'off',
        value: function off(eventName, callback) {
            if (this._eventListeners[eventName]) {
                this._eventListeners[eventName] = this._eventListeners[eventName].filter(function (handler) {
                    return callback !== handler;
                });
            }
        }
    }, {
        key: '_emit',
        value: function _emit(eventName, data) {
            var handlers = this._eventListeners[eventName];
            if (handlers) {
                for (var i = 0; i < handlers.length; i++) {
                    handlers[i](data);
                }
            }
        }
    }, {
        key: 'plugins',
        get: function get() {
            return this._plugins;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body.concat();
        }
    }]);

    return Program;
})(_Statement3['default']);

exports['default'] = Program;
;
module.exports = exports['default'];